﻿using System.Drawing;

namespace TestProject
{
    /// <summary>
    /// 트리 노드 인터페이스
    /// </summary>
    public interface ITreeNode
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method

        #region 크기 구하기 - GetSize(graphics, font)

        /// <summary>
        /// 크기 구하기
        /// </summary>
        /// <param name="graphics">그래픽스</param>
        /// <param name="font">폰트</param>
        /// <returns>크기</returns>
        SizeF GetSize(Graphics graphics, Font font);

        #endregion
        #region 포인트 위치 여부 구하기 - IsAtPoint(graphics, font, centerPoint, targetPoint)

        /// <summary>
        /// 포인트 위치 여부 구하기
        /// </summary>
        /// <param name="graphics">그래픽스</param>
        /// <param name="font">폰트</param>
        /// <param name="centerPoint">중심 포인트</param>
        /// <param name="targetPoint">타겟 포인트</param>
        /// <returns>포인트 위치 여부</returns>
        bool IsAtPoint(Graphics graphics, Font font, PointF centerPoint, PointF targetPoint);

        #endregion
        #region 그리기 - Draw(x, y, graphics, pen, backgroundBrush, textBrush, font)

        /// <summary>
        /// 그리기
        /// </summary>
        /// <param name="x">X 좌표</param>
        /// <param name="y">Y 좌표</param>
        /// <param name="graphics">그래픽스</param>
        /// <param name="pen">펜</param>
        /// <param name="backgroundBrush">배경 브러시</param>
        /// <param name="textBrush">텍스트 브러시</param>
        /// <param name="font">폰트</param>
        void Draw(float x, float y, Graphics graphics, Pen pen, Brush backgroundBrush, Brush textBrush, Font font);

        #endregion
    }
}